#!/bin/sh
#-------------------------------------------------------------------
#
# Wikipedia Skript
#
# Begriffe von pda.de.wapedia.org suchen
#
# Name: wiki.sh
#
# V1.4
#
# Eingabe des Suchbegriffs ber die msgbox
# Ausgabe ber TXTHTML Funktion von Tuxwetter
# Aufruf ber das Flexmenu:
#
# ACTION=&Wikipedia,(/var/plugins/wiki.sh)
#
# V1.1  die bersetzung kann nun auch mehrere Worte umfassen
#
# V1.1a Aenderung im Seitenaufbau alt: <b>wapedia</b> neu: <b>wapedia.mobi</b>
#
# V1.1b Anpassung fuer DBox2 von SnowHead
#
# V1.1c Anpassung an den neuen Webserver 3.0.6 von robspr1 und DrStoned
#
# V1.2 Anpassung an Robotsperre bei Wiki und neues Seitenformat von SnowHead
#      Angabe von Kommandozeilenparameter moeglich
#
# V1.3 andere Anonymisierung verwendet
#      funkttioniert nun wieder in allen Images
#
# V 1.4 An gendertes Seitenlayout von wiki angepasst
#
# Einschrnkung:
# Sonderzeichen und Umlaute werden nicht immer
# korrekt umgewandelt, da leider nicht immer
# die gleichen Zeichencodes verwendet werden.
# Aufgrund der Komplexitt mancher Seiten
# ist nicht immer eine saubere Darstellung
# gewhrleistet.
#
# Author: barabas
#-------------------------------------------------------------------
# falls TuxWetter mit externer libcurl verwendet
# wird muss LD_LIBRARY_PATH gesetzt sein
# export LD_LIBRARY_PATH=/var/bin/tuxwet

if [ `expr length "$1"` -gt 1 ]; then
	suche="$1"
else
	suche="_"
fi

until [ ! "$suche" ]; do

 if [ `expr length "$1"` -eq 0 ]; then
 	suche=`input t='Zu suchenden Begriff eingeben:' l='@@@@@@@@@@@@@@@@@@@@@@@@@' k=1 d="$suche"`
 fi

 if [ "$suche" ]; then

  # bei mehreren Woertern Leerzeichen durch + ersetzen
    wikisuche="`echo $suche | sed -e 's/[ ]*^//g' -e 's/ /%20/g'`"
    wget -O- "http://anonymouse.org/cgi-bin/anon-www_de.cgi/http://pda.wapedia.mobi/de/$wikisuche" |\
    sed -e s/'\&nbsp;'/''/g -e s/'<\/td>'/'\n'/g -e s/'<\n\n>'/'\n'/g -e s/'<B>'/'~G'/g -e s/'<\/B>'/'~S'/g -e s/'\&reg;'/''/g |\
    sed 's/ü/\&uuml;/g
         s/Ü/\&Uuml;/g
         s/ö/\&ouml;/g
         s/Ö/\&Ouml;/g
         s/ß/ss/g
         s/ä/\&auml;/g
         s/Ä/\&Auml;/g
            /^$/d' | sed '1 d' >/tmp/wiki.htm

    # bischen bloed mit grep hab aber grad keine bessere Idee
    if [ `grep -c 'e' /tmp/wiki.htm` -gt 0 ]
      then
      /var/plugins/tuxwet/tuxwetter "TXTHTML=Wikipedia Eintrag f~ur $suche,http://localhost/tmp/wiki.htm|wapedia.mobi/pics/logo.gif|</body>"
    else
      msgbox size=32 refresh=2 "title=Fehler" msg="~cSuchbegriff: $suche nicht gefunden!~n~n~Y~c!!! Der Wikipedia-Server ist nicht erreichbar !!!~n~n~c!!! Kontrollieren Sie Ihre Internetverbindung !!!"
    fi
 fi

 if [ `expr length "$1"` -gt 0 ]; then
 	$suche=""
 fi

done

rm /tmp/wiki.htm